# -*- coding: utf-8 -*-

import os, re
from PyQt4.QtCore import PYQT_VERSION_STR, QStringList
from moteur_modules_common.EkdProcess import EkdProcess
from moteur_modules_common.EkdCompatiblePython2Et3 import EkdPrint

def verifAppliManquante():

    # -------------------------------------
    # Dépendances ...
    # Vérification de la présence des logs
    # indispensables au lancement d'EKD
    # -------------------------------------

    EkdPrint(u"")
    manquantes = []

    all = ['pyqt4', 'python imaging library', 'numpy', 'mplayer', 'mencoder',\
    'imagemagick', 'ffmpeg', 'ffmpeg2theora', 'sox']

    ### Les vérifications pour FFMPEG sont valables pour Win.
    if os.name in ['posix', 'mac']:

        commandesBash = ['mplayer', 'mencoder', 'composite', 'ffmpeg', 
                            'ffmpeg2theora', 'sox']

        for commande in commandesBash:
            resultat = os.popen("which " + commande).readline()
            if not resultat:
                if commande == 'composite': manquantes.append('imagemagick')
                else: manquantes.append(commande)

    fmsg = 0
    #### A modifier ###########
    #msgffmpeg = QStringList()
    temp_msgffmpeg = []
    ###########################
    listformats = QStringList()
    convertformat = []
    
    # Ici la liste a eu qques modifs (par exemple [1,"VCD","VCD","","mpg"] est devenu [1,"vcd","VCD","","mpg"]
    ffmpeglib = [[0,"raw","RAW DV (dv)","","dv"],[1,"vcd","VCD","","mpg"],[2,"svcd","SVCD","","mpg"],[3,"dvd","DVD","","mpg"],[4,"flv","Flash FLV","","flv"],[5,"ogg","Theora (ogg)","--enable-libtheora","ogg"],[6,"mjpeg","MJPEG (avi)","","avi"],[7,"libxvid","Xvid (avi)","--enable-libxvid","avi"],[8,"h264","H264 (avi)","--enable-libx264","avi"]]
    
    if os.name !='nt' :
        cheminFFmpeg="ffmpeg"
      
        # La commande: ffmpeg -version car cette dernière commande n'existe
        # plus dans certaines versions de FFmpeg (enfin dans le fork)
        f = EkdProcess(u'"%s" -version' % (cheminFFmpeg))

        verffmpeg = f.communicate()[1]

        # Vérification de la version de FFmpeg pour les fonctions AVCHD
        z = verffmpeg.split("\n")
        avchd = False
        for a in z :
            ## Utilisation des expression regulières
            if re.match('\s+libavformat.*', a):
                ffmpegversion = re.findall("\d+", a)[0]
                if int(ffmpegversion) >= 52 :
                    avchd = True
                    
	# Liste des codecs contenus dans la liste ffmpeglib
	codec_ffmpeg_ekd = [cekd[1] for cekd in ffmpeglib]
	
	for com in codec_ffmpeg_ekd:
	    commande1 = unicode(cheminFFmpeg) + u' -codecs'
	    commande2 = unicode(cheminFFmpeg) + u' -formats'
	    # Dans les dernières versions de FFmpeg on a deux commandes 
	    # différentes: ffmpeg -formats et ffmpeg -codecs. Dans la
	    # version installée sous Ubuntu 10.04 la commande 
	    # ffmpeg -codecs n'existe pas, mais elle existe sous
	    # Ubuntu 12.04 (et dans les nouvelles versions de FFmpeg)
	    com_temp_1 = EkdProcess(commande1)
	    com_temp_2 = EkdProcess(commande2)
	    # Le résultat de res_temp_1 est récupéré dans stdout et le
	    # résultat de res_temp_1_stderr est récupéré dans stderr
	    res_temp_1, res_temp_1_stderr = com_temp_1.communicate()
	    # Le résultat de res_temp_2 est récupéré dans stdout (uniquement)
	    res_temp_2 = com_temp_2.communicate()[0]
	    # Sortie en stderr (commande 1) ds une liste
	    res_1_stderr = [res_temp_1_stderr]
	    # Sortie commande 1 placée dans une liste
	    res1 = [res_temp_1]
	    # Sortie commande 2 placée dans une liste
	    res2 = [res_temp_2]

	    # Si la commande n'existe pas (encore), la liste est vidée
	    # (elle n'est par défaut pas vide en utilisant EkdProcess)
	    for parc_res_1_stderr in res_1_stderr:
		# Si la commande ffmpeg -codecs nexiste pas ... on retourne une liste vide
		if "missing argument for option '-codecs'" in parc_res_1_stderr: res1 = []
	    
	    # ---------------------
	    # Si la commande: ffmpeg -codecs existe bel et bien, certains 
	    # éléments de la liste ffmpeglib s'en trouveront changés
	    if len(res1) == 0: res = res2
	    # Autrement (par exemple si len(res1) > 0)
	    else:
		for fm1 in ffmpeglib:
		    if fm1[1] == "ogg": fm1[1] = "libtheora"
		    if fm1[1] == "h264": fm1[1] = "libx264"
		res = res1 + res2
		# Liste des codecs contenus dans la liste ffmpeglib (après changement)
		codec_ffmpeg_ekd = [c[1] for c in ffmpeglib]
	    # ---------------------

	    # Liste pour le data 1
	    liste_data = []
	    # Liste des formats codecs sélectionnés
	    for parc_res in res:
	       for parc_cfe in codec_ffmpeg_ekd:
		   # Expression régulière pour trouver les occurrences 
		   # commençant par la lettre E (donc E pour Encode)
		   # Equivalent de la commande: ffmpeg -formats | grep -wE codec
	           trouver = re.compile('(E.*?.' + parc_cfe + ')')
	           liste_data.append(trouver.findall(parc_res))
	           
	# Split des données. Affiche par exemple: 
	# [..., ['E', 'mjpeg'], ['EV', 'D', '', 'mjpeg'], ..., ['E', 'h264']]
	lsplit = [parc_data_2.split(" ") for parc_data_1 in liste_data for parc_data_2 in parc_data_1] 
	# On enlève certaines parties qui encombrent
	encombre = ['(', '', 'E', 'S', 'EV', 'ED', 'EVSD', 'ES', 'D', 'A', 'System', 'format']
	rem = [x for y in lsplit for x in y if x not in encombre and x[0] != encombre[0]]

	# Les doublons sont retirés
	rem_doubles = list(set(rem))
 
	# Elements communs entre la liste codec_ffmpeg_ekd et la liste
	# rem_doubles (qui contient les codecs détectés, voir au-dessus)
	inter = list(set(codec_ffmpeg_ekd).intersection(set(rem_doubles)))
 
	# Voir s'il y a des différences
	diff = list(set(codec_ffmpeg_ekd).difference(set(inter)))

	# Nonbre d'éléments dans diff
	nbre_diff = len(diff)
   
	# Repère la ligne du codec fautif dans la liste ffmpeglib
	codec_fautif = [parc_ff for parc_ff in ffmpeglib for parc_diff in diff if parc_ff[1] == parc_diff]

	# ----------------------------------------------------------------- #
	# Recherche et comparaison pour le librairie incluses dans FFmpeg
	# (lignes --enable-librairie) et ce pour affichage
	# ----------------------------------------------------------------- #
	# Split  de verffmpeg
	verffmpegtemp = verffmpeg.split(' ')

	# Récup des codecs impactés par les lignes --enable dans ffmpeglib
	enbl = [el[1] for el in ffmpeglib if el[3] != '']

	# Ligne --enable-librairie incluse dans FFmpeg
	enable_lib = [en2[1] for en1 in verffmpegtemp for en2 in ffmpeglib if en2[3] != '' and en1 == en2[3]]
	
	# Nombre d'occurences des librairies (--enable-librairie incluse
	# dans FFmpeg) communes entre FFmpeg et celles contenues dans ffmpeglib
	nbre_en_lib = len(enable_lib)
	
	# Dans certaines configs de FFmpeg (par exemple dans FFmpeg de la versions
	# 12.04 d'Ubuntu) la commande ffmpeg -version n'existe pas (selon au moins
	# une personne de la liste FFmpeg users il ne s'agit pas de vraiee version 
	# de FFmpeg mais de forks). Si la version de FFmpeg est une vraie version ...
	# Pour le détail concernant ce fork de FFmpeg sur Ubuntu:
	# https://launchpad.net/~jon-severinsson/+archive/ffmpeg
	# Voir aussi ce post d'Olivier pour OpenShot (Olivier --> Cenwen):
	# http://openshotusers.com/forum/viewtopic.php?f=12&t=1261
	#
	# On utilise nbre_en_lib pour savoir à quelle version de FFmpeg on a à 
	# faire. Ici si la liste enable_lib est vide (donc qu'il n'y a aucune 
	# référence aux parties --enable-librairie)
	if nbre_en_lib > 0:

	    # Repérage des librairies (--enable-librairie) non incluses
	    # dans FFmpeg (et ce comparativement à ffmpeglib)
	    diff_enable = list(set(enbl).difference(set(enable_lib)))

	    # Mise en forme des données pour affichage
	    enable = [e1 for e1 in ffmpeglib for e2 in diff_enable if e2 == e1[1]]

	    # Si enable contient au moins une donnée, 
	    # codec_fautif prend la valeur de enable
	    if len(enable) > 0:
		nbre_diff = len(enable)
		codec_fautif = enable

	    # Codecs actifs à afficher dans les listes déroulantes
	    cod_act = list(set(inter).difference(set(diff_enable)))
	    codecs_actifs = [cd1 for cd1 in ffmpeglib for cd2 in cod_act if cd2 == cd1[1]]
	    
	else:
	    # S'il s'agit du fork de FFmpeg ...
	    
	    # Codecs actifs à afficher dans les listes déroulantes
	    codecs_actifs = [ii1 for ii1 in ffmpeglib for ii2 in inter if ii2 == ii1[1]]
	# ----------------------------------------------------------------- #
	    
	for ff1 in ffmpeglib:
	    # Si la liste codec_fautif contient des données
	    if nbre_diff > 0:
		for parc_cod_faut in codec_fautif:
		    ff1 = parc_cod_faut
		    temp_msgffmpeg.append(_(u"Le package ffmpeg installé n'inclut pas %s et n'est pas capable d'encoder en %s. Ce format sera désactivé de l'interface utilisateur.") % (ff1[1],ff1[2]))
	  
	# On enlève les doublons dans la liste temporaire
	temp_msgffmpeg = list(set(temp_msgffmpeg))

	# La liste devient une QStringList
	msgffmpeg = QStringList()
	
	# Parcours de la liste temporaire et
	# et templissage de la QStringList
	for m in temp_msgffmpeg:
	    fmsg = 1
	    msgffmpeg.append(m)
	
	# Listes déroulantes (codecs). Dans Vidéo > Diaporama d'images en vidéo,
	# La liste Format du fichier de sortie (dans Réglages) est remplie par
	# les codecs supportés
	for cact in codecs_actifs:
	    listformats.append(cact[2])
	    convertformat.append((cact[0],cact[1],cact[4]))

    else :
        fmsg = 0
        msgffmpeg = u""
        avchd = True
        for ff in ffmpeglib :
            listformats.append(ff[2])
            convertformat.append((ff[0],ff[1],ff[4]))
    soxErr = False
    msgsox = u""
    
    try: from PyQt4 import QtGui, QtCore
    except ImportError, e:
        manquantes.append('python-qt4')
        print "ImportError:", e

    try: from numpy import lib
    except ImportError, e:
        manquantes.append('python-numpy')
        print "ImportError:", e

    try: from PIL import Image
    except ImportError, e:
        manquantes.append('python-imaging')
        print "ImportError:", e

    a=u'\n'+u'='*40+u'\n'
    if manquantes:
        apps = u', '.join(manquantes)
        m1=u"Les applications suivantes n'ont pas été détectées:\n"
        m2=u"\nEKD ne sera pas pleinement fonctionnel (s'il démarre...)\n\
        \nYou must install the packages:\n"
        EkdPrint(u"%s %s %s %s %s %s %s %s" % (a, m1, apps, m2, apps, a, msgffmpeg, msgsox))
        return 0, ', '.join(manquantes), fmsg, msgffmpeg, listformats, convertformat, soxErr, msgsox

    else:
        EkdPrint(u'PyQT version : %s' % QtCore.PYQT_VERSION_STR)
        m = u"Toutes les dépendances sont satisfaites\n\nAll packages are installed"
        return 1, ', '.join(all), fmsg, msgffmpeg, listformats, convertformat, soxErr, msgsox, avchd
